<template>
    <v-app class="mn-app-container">
        <app-dialogs/>
        <main-sidebar v-model="drawer" @toggleClick="drawer = !drawer" />

        <v-app-bar app dense id="omm-app-bar">
            <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>
            <file-name/>
            <v-spacer></v-spacer>
            <action-buttons/>
        </v-app-bar>

        <v-main id="omm-main">
            <router-view/>
        </v-main>

        <context-menu/>
    </v-app>
</template>

<script lang="ts">
import MainSidebar from "@/components/layout/MainSidebar.vue";
import ContextMenu from "@/components/ContextMenu.vue";
import FileName from "@/components/FileName.vue";
import ActionButtons from "@/components/ActionButtons.vue";
import AppDialogs from "@/components/dialogs/AppDialogs.vue";

import { defineComponent, onBeforeMount, onMounted, onUpdated, watch } from '@vue/composition-api';
import { useSettings, useContents, useAppStatus, useObservers, useShortcuts } from "./compositions";
import { AppStorage } from "./ts";
import { getAppTheme } from "@/ipc";

export default defineComponent({
    name: "App",
    components: {
        MainSidebar,
        ContextMenu,
        FileName,
        ActionButtons,
        AppDialogs
    },
    data: () => ({drawer: null}),
    setup(props, {root}) {
        /**
         * Fetches storages from the settings and set the current storage global state.
         */
        const initStorage = async () => {
            useAppStatus().setAppReady(false);

            const allStorages: AppStorage[] = await useSettings().updateStorage();
            const defaultStorage: AppStorage[] = allStorages.filter((storage) => storage.default);
            const currentStorage = defaultStorage.length ? defaultStorage[0] : allStorages[0];

            useContents().setCurrentStorage(currentStorage);
            useAppStatus().setAppReady(true);
        }

        let unregisterGlobalObservers: Record<string, Function>;

        const registerGlobalObservers = () => {
            if (unregisterGlobalObservers) {
                const unregisterFunctions = Object.values(unregisterGlobalObservers);

                if (unregisterFunctions.length) {
                    unregisterFunctions.forEach((method) => method());
                }
            }

            unregisterGlobalObservers = useObservers().registerObserverMultiple([ 'fileNameUpdated', 'dirNameUpdated' ], {
                actionName: 'UPDATE_TREE_NODE_NAME'
            });
        }

        /**
         * Retrieves the app theme from the settings and assign it to the current theme app variable.
         */
        const initAppTheme = async () => {
            const appTheme = await getAppTheme();
            useContents().setCurrentTheme(appTheme);

            root.$vuetify.theme.dark = useContents().isDarkMode.value;
        }

        onUpdated(() => {
            initStorage();
            registerGlobalObservers();
        });

        onBeforeMount(() => {
            initStorage();
            registerGlobalObservers();
            useShortcuts().initShortcuts();
        });

        watch(useContents().isDarkMode, (isDarkMode) => {
            root.$vuetify.theme.dark = isDarkMode;
        });

        onMounted(() => {
            initAppTheme();
        });
    }
});
</script>

<style lang="scss">
.mn-app-container {
    height: 100vh;
    position: relative;

    /* width */
    ::-webkit-scrollbar {
        width: 10px;
    }

    .theme--dark {
        /* width */
        ::-webkit-scrollbar {
            width: 10px;
        }

        /* Track */
        ::-webkit-scrollbar-track {
            background: transparent;

            &:hover {
                background: var(--v-secondary-darken1);
            }
        }

        /* Handle */
        ::-webkit-scrollbar-thumb {
            background: var(--v-secondary-lighten1);

            &:hover {
                background: var(--v-secondary-lighten2);
            }
        }
    }

    .theme--light {
        /* Track */
        ::-webkit-scrollbar-track {
            background: transparent;

            &:hover {
                background: var(--v-secondary-lighten5);
            }
        }

        /* Handle */
        ::-webkit-scrollbar-thumb {
            background: var(--v-secondary-lighten4);

            &:hover {
                background: var(--v-secondary-lighten2);
            }
        }
    }
}
</style>
